#ifndef _FILLMATRIX_H__
#define _FILLMATRIX_H__

#include "Mathmatics.h"
#include "penalty_info.h"
#include <algorithm> //Eigentlich in Header
#include <assert.h>
#include <ctype.h>
#include <iostream>
#include <math.h>
#include <stdlib.h> 
#include <string.h>


struct ArrayElem { //24B
  double score;
  int prev_j;
  int prev_i;
  int prev_matrix_no;   
  bool isSplice;
} ;

struct pre_score { //24B
  double value; //8
  int prev_i; //4
  int prev_j; //4
  int prev_matrix_no;//4
  bool issplice;//4
};

typedef struct pre_score Pre_score;

typedef struct Align_pair { //24B
  double value ; 
  bool issplice;
  int previ,prevj ;
  char est_char;
  char dna_char;
};


void fill_matrix (int nr_paths, Pre_score* matrices[], int len_est, int len_dna, char* est, char* dna, double* prb, penalty_struct* functions, double* matchmatrix, penalty_struct* qualityScores, double* donor, double* acceptor, bool remove_duplicate_scores, int nr_donor_sites, int* donor_sites, int* max_score_positions);
// funktion aendern in void result_align(Pre_score* matrices[], int anzpath,

int check_char(char base);

bool result_align (Pre_score* matrices[], int matrixnr, int i,  int j, int* result_length_ptr, char* est, char* dna, int* s_align, int* e_align, int* m_param, double* alignmentscores, int* max_score_positions );

extern void print_align(Pre_score* matrix, int length_est,  int length_dna, Align_pair* vektor, int result_length, int print_matrix);

double getScore(double *matchmatrix,int mlen, int dnaChar, int estChar);


double scoreMatch(int dnaChar, int estChar, double baseScore);


#endif // _FILLMATRIX_H__
