#!/usr/bin/env python 
# -*- coding: utf-8 -*- 

class Gene:
   
   def __init__(self,chr,begin,end,strand,id):
      assert chr != ''
      assert begin >= 0 and begin <= end and end >= 0
      assert strand in ['+','-']

      self.chromosome = chr
      self.start = begin
      self.stop = end
      self.strand = strand
      self.exons = []
      self.fiveUTR = []
      self.threeUTR = []
      self.id = id

   def addExon(self,start,stop):
      self.exons.append((start,stop))

   def load(self,filename):
      pass

   def save(self,filename):
      pass
