%module QPalmaDP
%{
#define SWIG_FILE_WITH_INIT
#include "common.h"
#include "Mathmatics.h"
#include "penalty_info.h"
#include "qpalma_dp.h"
%}

%include "carrays.i"

%include "common.h"
%include "Mathmatics.h"
%include "penalty_info.h"
%include "qpalma_dp.h"

%array_class(int, intArray) ;
%array_class(double, doubleArray) ;
%array_functions(struct penalty_struct, penaltyArray) ;

/*
%array_functions(double, doubleFArray) ;
%array_class(Pre_score, Pre_scoreArray) ;
*/

%pythoncode
%{

def createPenaltyArrayFromList(list):
   array = new_penaltyArray(len(list))
   for i in range(len(list)):
      penaltyArray_setitem(array, i, list[i])
   return array

def createDoubleArrayFromList(list):
   #array = new_doubleArray(len(list))
   array = doubleArray(len(list))
   for i in range(len(list)):
   #   doubleArray_setitem(array, i, list[i])
      array[i] = list[i]
   return array

def createIntArrayFromList(list):
   #array = new_intArray(len(list))
   array = intArray(len(list))
   for i in range(len(list)):
      #intArray_setitem(array, i, list[i])
      array[i] = list[i]
   return array

def createListFromIntArray(array, array_len):
   list = [0]*array_len
   for i in range(array_len):
      list[i] = intArray_getitem(array,i)
   return list

def createListFromDoubleArray(array, array_len):
   list = [0]*array_len
   for i in range(array_len):
      list[i] = doubleArray_getitem(array,i)
   return list
%} 
